unit Display;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs;

type
  TForm2 = class(TForm)
    procedure FormPaint(Sender: TObject);
  private
    { Private declarations }
    procedure DrawCaption( obX, obY: integer; Caption : string);
  public
    procedure DrawConnector(ob1X,ob1Y,ob2X,ob2Y: integer);
    procedure DrawShop(X, Y: integer;Caption : string);
    procedure DrawAccumulator(X, Y: integer;Caption : string);
    { Public declarations }
  end;

var
  Form2: TForm2;

implementation

{$R *.DFM}
const
  Size = 20;
  CaptionSpace = 2;
  BorderSpace = 20;
  GridSpace = Size + 20;

procedure TForm2.DrawCaption( obX, obY: integer; Caption : string);
begin
  with Canvas do TextOut(obX, obY+Size+CaptionSpace, Caption);
end;

procedure TForm2.DrawConnector(ob1X,ob1Y,ob2X,ob2Y : integer);
begin
  Canvas.PolyLine([Point(ob1X+ Size div 2,ob1Y + Size div 2),
                  Point(ob2X +Size div 2,ob2Y +Size div 2)])
end;

procedure TForm2.DrawShop(X,Y: integer ; Caption : string);
begin
  Canvas.Ellipse(X,Y,X+Size,Y+Size);
  DrawCaption (X,Y,Caption);
end;

procedure Tform2.DrawAccumulator(X,Y: integer ;Caption: string);
begin
  Canvas.Rectangle(X,Y,X+Size,Y+Size);
  DrawCaption (X,Y,Caption);
end;

procedure TForm2.FormPaint(Sender: TObject);
begin
  DrawConnector(BorderSpace, BorderSpace,BorderSpace+GridSpace,BorderSpace+GridSpace);
  DrawConnector(BorderSpace, BorderSpace + GridSpace,BorderSpace+GridSpace,BorderSpace+GridSpace);
  DrawConnector(BorderSpace, BorderSpace  + 2 * GridSpace,BorderSpace+GridSpace,BorderSpace+GridSpace);

  DrawShop(BorderSpace, BorderSpace, '1');
  DrawShop(BorderSpace, BorderSpace + GridSpace, '2');
  DrawShop(BorderSpace, BorderSpace  + 2 * GridSpace, '3');

  DrawConnector(BorderSpace+GridSpace,BorderSpace+GridSpace,BorderSpace+2*GridSpace, BorderSpace+GridSpace);

  DrawAccumulator(BorderSpace+GridSpace,BorderSpace+GridSpace, 'ACC');

  DrawConnector(BorderSpace+2*GridSpace, BorderSpace+GridSpace,BorderSpace+3*GridSpace, BorderSpace);
  DrawConnector(BorderSpace+2*GridSpace, BorderSpace+GridSpace,BorderSpace+3*GridSpace, BorderSpace+GridSpace);
  DrawConnector(BorderSpace+2*GridSpace, BorderSpace+GridSpace,BorderSpace+3*GridSpace, BorderSpace+ 2* GridSpace);


  DrawShop(BorderSpace+2*GridSpace, BorderSpace+GridSpace, '');

  DrawShop(BorderSpace+3*GridSpace, BorderSpace, '1');
  DrawShop(BorderSpace+3*GridSpace, BorderSpace+GridSpace, '2');
  DrawShop(BorderSpace+3*GridSpace, BorderSpace+ 2* GridSpace, '3');
end;

end.
