unit MainFrm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, QSheme,
  StdCtrls,QSObjs,QSTypes,MyAcc,ExtCtrls,Utils, Gauges, ComCtrls, MyExt,
  Spin;

const
  MaxManNumber = 3;

type
  TForm1 = class(TForm)
    Button4: TButton;
    Button1: TButton;
    Gauge1: TGauge;
    GroupBox4: TGroupBox;
    lvResults: TListView;
    GroupBox1: TGroupBox;
    GroupBox2: TGroupBox;
    cbTimeUnits1: TComboBox;
    Label3: TLabel;
    GroupBox5: TGroupBox;
    Label4: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label5: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label1: TLabel;
    cbTimeUnits: TComboBox;
    Button2: TButton;
    edMeanArms: TSpinEdit;
    edDispArms: TSpinEdit;
    edStringCount: TSpinEdit;
    edMeanMind: TSpinEdit;
    edDispMind: TSpinEdit;
    edMeanPC: TSpinEdit;
    edDispPC: TSpinEdit;
    edSysPeriod: TSpinEdit;
    CheckBox1: TCheckBox;
    Button3: TButton;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Button4Click(Sender: TObject);
    procedure Button10Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure DiagramPaint(Sender: TObject);
    procedure CreateMan(var AMan : TMan; AId: integer);
    procedure LoadParams;
    procedure LoadDefaults;
    procedure Button2Click(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    //procedure Analize;
    procedure DisplayStatistics;
    //procedure StartAnalize;
    procedure InitInterface;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

  Sheme : TQSheme;

  Men : array [0.. MaxManNumber - 1] of TMan;
  Queue : TMyAccum;
  PC: TPC;

implementation

uses Display;

{$R *.DFM}


procedure TForm1.LoadDefaults;
begin
  cbTimeUnits.ItemIndex := tuHours;
  cbTimeUnits1.ItemIndex := tuSeconds;
  edSysPeriod.Text := '6';
  edMeanArms.Text := '10';
  edDispArms.Text := '5';
  edMeanMind.Text := '30';
  edDispMind.Text := '0';
  edStringCount.Text := '10';
  edMeanPC.Text := '10';
  edDispPC.Text := '3';
end;

procedure TForm1.LoadParams;
var i : integer;
    k : integer;
begin
  k := 1;
  case cbTimeUnits.ItemIndex of
    tuDays : k := 3600000 * 24;
    tuHours : k:= 3600000;
    tuMinutes : k := 60000;
    tuSeconds : k := 1000;
  end;
  Sheme.SysPeriod := k * Round(StrToFloat(edSysPeriod.Text));

  case cbTimeUnits1.ItemIndex of
    tuDays : k := 3600000 * 24;
    tuHours : k:= 3600000;
    tuMinutes : k := 60000;
    tuSeconds : k := 1000;
    tuMilliseconds : k := 1;
  end;

  for i := 0 to MaxManNumber - 1 do
    with Men[i] do begin
      Arms.Generator.Mean := k * StrToInt(edMEanArms.Text);
      Arms.Generator.Disp := k * StrToInt(edDispArms.Text);
      Mind.Generator.Mean := k * StrToInt(edMeanMind.Text);
      Mind.Generator.Disp := k * StrToInt(edDispmind.Text);
      Arms.StringCount := StrToInt(edStringCount.Text);
    end;
  with PC do begin
    Generator.Mean := k * StrToInt(edMeanPC.Text);
    Generator.Disp := k * StrToInt(edDispPC.Text);
  end;

end;

procedure TForm1.CreateMan(var AMan: TMan; Aid : integer);
begin
  AMan := TMan.Create;
  with AMan do begin
    Mind := TMind.Create;
    with Mind do begin
      Man := AMan;
      Name := 'Mind'+IntToStr(AId);
      Id := AId;
    end;
    Sheme.AddElement(Mind);
    Mind.AddSource(PC);

    Arms := TArms.Create;
    with Arms do begin
      Man := AMan;
      Id := AId;
      Name := 'Arms'+IntToStr(AId);
    end;
    Sheme.AddElement(Arms);
    Queue.AddSource(Arms);
  end;
end;



procedure TForm1.InitInterface;
begin
  LoadDefaults;
end;

procedure TForm1.FormCreate(Sender: TObject);
var i : integer;
begin
  // 
  Sheme := TQSheme.Create;
  Sheme.ParcelsClass := TMyParcel;

  PC := TPC.Create;
  PC.Name := 'PC';
  Sheme.AddElement(PC);
  PC.Generator.RandomType := rtPlane;


  Queue := TMyAccum.Create;
  Queue.Name := 'Queue';
  Sheme.AddElement(Queue);
  PC.Queue := Queue;

  PC.AddSource(Queue);

  for i := 0 to MaxManNumber - 1 do CreateMan(Men[i],i);

  InitInterface;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
  procedure FreeMan(AMan : TMan);
  begin
    with AMan do begin
      Arms.Free;
      Mind.Free;
    end;
    AMan.Free;
  end;
var i : integer;
begin
  Sheme.Free;
  for i := 0 to MaxManNumber - 1 do FreeMan(Men[i]);
  Queue.Free;
  PC.Free;
end;

{var
  FinishElements : TList;
  SourceElements : TList;
  Iterations : integer;
const
  StepX : integer = 50;
  StepY : integer = 30;

procedure TForm1.Analize;
var i,j : integer;
begin}
{  if FinishElements.Count = 0 then Exit;
  Inc(Iterations);
  for i := 0 to FinishElements.Count - 1 do begin
    for j := 0 to TElement(FinishElements[i]).SourceCount - 1 do begin
      with Display do begin
        Canvas.MoveTo(Width - StepX * Iterations,i * StepY);
        Canvas.LineTo(Width - StepX * (Iterations+1),j * StepY);
      end;
      if SourceElements.IndexOf(TElement(FinishElements[i]).Sources[j]) < 0 then
        SourceElements.Add(TElement(FinishElements[i]).Sources[j]);
    end;
  end;
  for i := 0 to FinishElements.Count - 1 do begin
    with Display do begin
      Canvas.TextOut(Width - StepX*Iterations,i*StepY,
              TElement(FinishElements[i]).Name);
    end;
  end;
  SwapPointers(Pointer(FinishElements),Pointer(SourceElements));
  SourceElements.Clear;
  Analize;
end;}


{procedure TForm1.StartAnalize;
var i : integer;
  function IsFinishElement(Element : TElement): Boolean;
  var j,s : integer;
  begin
    Result := False;
    with Sheme do
    for j := 0 to ElementCount-1 do begin
      for s := 0 to Elements[j].SourceCount-1 do begin
        if Element = Elements[j].Sources[s] then Exit;
      end;
    end;
    Result := True;
  end;
begin
  Iterations := 0;
  FinishElements := TList.Create;
  SourceElements := TList.Create;
  with Sheme do
  for i := 0 to ElementCount-1 do begin
    if IsFinishElement(Elements[i]) then FinishElements.Add(Elements[i]);
  end;
  Analize;
  FinishElements.Free;
  SourceElements.Free;
end;}

procedure TForm1.Button4Click(Sender: TObject);
begin
  Close
end;

procedure TForm1.Button10Click(Sender: TObject);
begin
  //StartAnalize;
end;

procedure TForm1.DisplayStatistics;
  procedure AddResult(sVar,sValue : string);
  var I : TListItem;
  begin
    with lvResults do begin
      i := Items.Add;
      i.Caption := sVar;
      i.SubItems.Add(sValue);
    end;
  end;

var i : integer;

begin
  lvREsults.Hide;
  lvResults.Items.Clear;
  lvREsults.Show;
  AddResult('  ',IntToStr(Sheme.BornParcelCount));
  AddResult('  ', IntToStr(Sheme.StoreParcelCount));
  AddResult('  ', IntToStr(Sheme.WorkParcelCount));
  AddResult(' ',IntToStr(Sheme.PassedParcelCount));
  AddResult(' ', IntToStr(Sheme.RefusedParcelCount));

  for i := 0 to MaxManNumber -1 do begin
{$ifdef FullInfo}
    AddResult(''+IntToStr(i), IntToStr(Men[i].ParcelsWaiting));
    AddResult('   '+IntToStr(i+1)+'- ', IntToStr(Men[i].ParcelsPassed));
{$endif}
    AddResult('  '+IntToStr(i+1)+'- ', FloatToStrF(Men[i].ProbablyWait*100,ffGeneral,3,5)+'%');
  end;
{$ifdef FullInfo}
  AddResult('MaxParcelQ', IntToStr(Queue.MaxParcels));
{$endif}
  AddResult('  ', FloatToStrF(PC.LoadFactor*100,ffGeneral,3,5)+'%');

  AddResult('   ', IntToStr(Sheme.ParcelCount));
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  LoadParams;
  Queue.MaxParcels := 0;
  Sheme.Emulation;
  DisplayStatistics;
end;

procedure TForm1.DiagramPaint(Sender: TObject);
begin
  Sheme.RedrawDiagram;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  LoadDefaults;
end;

procedure TForm1.CheckBox1Click(Sender: TObject);
begin
  form1.ShowHint := CheckBox1.Checked;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  Form2.Show;
end;

end.
